## dolfin 2016.2.0

=== CMakeLists.txt ===
# Top level CMakeLists.txt file for DOLFIN

# Require CMake 3.5
cmake_minimum_required(VERSION 3.5)

#------------------------------------------------------------------------------
# Set project name and version number

project(DOLFIN)
set(DOLFIN_VERSION_RELEASE 1)
set(DOLFIN_VERSION_MAJOR "2016")
set(DOLFIN_VERSION_MINOR "2")
set(DOLFIN_VERSION_MICRO "0")
set(DOLFIN_VERSION "${DOLFIN_VERSION_MAJOR}.${DOLFIN_VERSION_MINOR}.${DOLFIN_VERSION_MICRO}")
if (NOT DOLFIN_VERSION_RELEASE)
  set(DOLFIN_VERSION "${DOLFIN_VERSION}.dev0")
endif()

#------------------------------------------------------------------------------
# Require and use C++11

# Use C++11
set(CMAKE_CXX_STANDARD 11)

# Require C++11
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Do not enable compler-specific extensions
set(CMAKE_CXX_EXTENSIONS OFF)

#------------------------------------------------------------------------------
# Check compiler version

# Check for GCC version - earlier versions have insuffcient C++11
# support, or bugs.
if (CMAKE_COMPILER_IS_GNUCXX)
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8.3)
    message(FATAL_ERROR "GCC version must be at least 4.8.3 (for sufficient C++11  support and to avoid some compiler bugs). You have version ${CMAKE_CXX_COMPILER_VERSION}")
  endif()
endif()

#------------------------------------------------------------------------------
# Get GIT changeset, if available

# Check for git
find_program(GIT_FOUND git)

if (GIT_FOUND)
  # Get the commit hash of the working branch
  execute_process(COMMAND git rev-parse HEAD
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_COMMIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE
    )
else()
  set(GIT_COMMIT_HASH "unknown")
endif()

#------------------------------------------------------------------------------
# General configuration

# Set CMake options, see `cmake --help-policy CMP000x`
if (COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0004 NEW)
  cmake_policy(SET CMP0042 NEW)
endif()

# Set location of our FindFoo.cmake modules
set(DOLFIN_CMAKE_DIR "${DOLFIN_SOURCE_DIR}/cmake" CACHE INTERNAL "")
set(CMAKE_MODULE_PATH "${DOLFIN_CMAKE_DIR}/modules")

# Make sure CMake uses the correct DOLFINConfig.cmake for tests and demos
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${CMAKE_CURRENT_BINARY_DIR}/dolfin)

#------------------------------------------------------------------------------
# Configurable options for how we want to build

include(FeatureSummary)

option(BUILD_SHARED_LIBS "Build DOLFIN with shared libraries." ON)
option(CMAKE_USE_RELATIVE_PATHS "Use relative paths in makefiles and projects." OFF)
option(DOLFIN_AUTO_DETECT_MPI "Detect MPI automatically (turn this off to use the MPI compiler wrappers directly via setting CXX, CXX, FC)." ON)
option(DOLFIN_DEPRECATION_ERROR "Turn deprecation warnings into errors." OFF)
option(DOLFIN_ENABLE_BENCHMARKS "Enable benchmark programs." OFF)
option(DOLFIN_ENABLE_CODE_COVERAGE "Enable code coverage." OFF)
option(DOLFIN_ENABLE_DOCS "Enable generation of documentation." ON)
option(DOLFIN_ENABLE_GTEST "Enable C++ unit tests with Google Test if DOLFIN_ENABLE_TESTING is true (requires Internet connection to download Google Test when first configured)." ON)
option(DOLFIN_ENABLE_TESTING "Enable testing." OFF)
option(DOLFIN_IGNORE_PETSC4PY_VERSION "Ignore version of PETSc4py." OFF)
option(DOLFIN_SKIP_BUILD_TESTS "Skip build tests for testing usability of dependency packages." OFF)
option(DOLFIN_WITH_LIBRARY_VERSION "Build with library version information." ON)

add_feature_info(BUILD_SHARED_LIBS BUILD_SHARED_LIBS "Build DOLFIN with shared libraries.")
add_feature_info(CMAKE_USE_RELATIVE_PATHS CMAKE_USE_RELATIVE_PATHS "Use relative paths in makefiles and projects.")
add_feature_info(DOLFIN_AUTO_DETECT_MPI DOLFIN_AUTO_DETECT_MPI "Detect MPI automatically (turn this off to use the MPI compiler wrappers directly via setting CXX, CXX, FC).")
add_feature_info(DOLFIN_ENABLE_CODE_COVERAGE DOLFIN_ENABLE_CODE_COVERAGE "Enable code coverage.")
add_feature_info(DOLFIN_WITH_LIBRARY_VERSION DOLFIN_WITH_LIBRARY_VERSION "Build with library version information.")
add_feature_info(DOLFIN_ENABLE_TESTING DOLFIN_ENABLE_TESTING "Enable testing.")
add_feature_info(DOLFIN_ENABLE_GTEST DOLFIN_ENABLE_GTEST "Enable C++ unit tests with Google Test if DOLFIN_ENABLE_TESTING is true (requires Internet connection to download Google Test when first configured).")
add_feature_info(DOLFIN_ENABLE_BENCHMARKS DOLFIN_ENABLE_BENCHMARKS "Enable benchmark programs.")
add_feature_info(DOLFIN_ENABLE_DOCS DOLFIN_ENABLE_DOCS "Enable generation of documentation.")
add_feature_info(DOLFIN_SKIP_BUILD_TESTS DOLFIN_SKIP_BUILD_TESTS "Skip build tests for testing usability of dependency packages.")
add_feature_info(DOLFIN_DEPRECATION_ERROR DOLFIN_DEPRECATION_ERROR "Turn deprecation warnings into errors.")
add_feature_info(DOLFIN_IGNORE_PETSC4PY_VERSION DOLFIN_IGNORE_PETSC4PY_VERSION "Ignore version of PETSc4py.")

# Add shared library paths so shared libs in non-system paths are found
option(CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath." ON)
add_feature_info(CMAKE_INSTALL_RPATH_USE_LINK_PATH CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath.")

# Hande RPATH on OSX when not installing to a system directory, see
# https://groups.google.com/d/msg/fenics-dev/KSCrob4M_1M/zsJwdN-SCAAJ
# and https://cmake.org/Wiki/CMake_RPATH_handling#Always_full_RPATH.
if (APPLE)
  # The RPATH to be used when installing, but only if it's not a
  # system directory
  SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
  LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
  IF("${isSystemDir}" STREQUAL "-1")
     SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
  ENDIF("${isSystemDir}" STREQUAL "-1")
endif()

#------------------------------------------------------------------------------
# This should be removed when Clang support OpenMP is ready
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  option(DOLFIN_ENABLE_OPENMP "Enable OpenMP." OFF)
else()
  option(DOLFIN_ENABLE_OPENMP "Enable OpenMP." ON)
endif()

#------------------------------------------------------------------------------
# Enable or disable optional packages

# List optional packages
set(OPTIONAL_PACKAGES "")
list(APPEND OPTIONAL_PACKAGES "OpenMP")
list(APPEND OPTIONAL_PACKAGES "MPI")
list(APPEND OPTIONAL_PACKAGES "PETSc")
list(APPEND OPTIONAL_PACKAGES "PETSc4py")
list(APPEND OPTIONAL_PACKAGES "SLEPc")
list(APPEND OPTIONAL_PACKAGES "SLEPc4py")
list(APPEND OPTIONAL_PACKAGES "Trilinos")
list(APPEND OPTIONAL_PACKAGES "UMFPACK")
list(APPEND OPTIONAL_PACKAGES "CHOLMOD")
list(APPEND OPTIONAL_PACKAGES "SCOTCH")
list(APPEND OPTIONAL_PACKAGES "ParMETIS")
list(APPEND OPTIONAL_PACKAGES "zlib")
list(APPEND OPTIONAL_PACKAGES "Python")
list(APPEND OPTIONAL_PACKAGES "Sphinx")
list(APPEND OPTIONAL_PACKAGES "HDF5")
list(APPEND OPTIONAL_PACKAGES "VTK")

# Add options
foreach (OPTIONAL_PACKAGE ${OPTIONAL_PACKAGES})
  string(TOUPPER "DOLFIN_ENABLE_${OPTIONAL_PACKAGE}" OPTION_NAME)
  option(${OPTION_NAME} "Compile with support for ${OPTIONAL_PACKAGE}." ON)
  add_feature_info(${OPTION_NAME} ${OPTION_NAME} "Compile with support for ${OPTIONAL_PACKAGE}.")
endforeach()

# Python version
option(DOLFIN_USE_PYTHON3 "Use Python 3." OFF)

#------------------------------------------------------------------------------
# General compiler defintions

if (DOLFIN_DEPRECATION_ERROR)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DDOLFIN_DEPRECATION_ERROR")
endif()

#------------------------------------------------------------------------------
# Package-specific options

# None at the moment

#------------------------------------------------------------------------------
# Compiler flags

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug Developer MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Check for some compiler flags
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-pipe HAVE_PIPE)
if (HAVE_PIPE)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-pipe ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Add some strict compiler checks
CHECK_CXX_COMPILER_FLAG("-Wall -Werror -pedantic" HAVE_PEDANTIC)
if (HAVE_PEDANTIC)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-Wall -Werror -pedantic ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Debug flags
CHECK_CXX_COMPILER_FLAG(-g HAVE_DEBUG)
if (HAVE_DEBUG)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-g ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

CHECK_CXX_COMPILER_FLAG(-O2 HAVE_O2_OPTIMISATION)
if (HAVE_O2_OPTIMISATION)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-O2 ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Set 'Developer' build type flags
set(CMAKE_CXX_FLAGS_DEVELOPER "${DOLFIN_CXX_DEVELOPER_FLAGS}" CACHE STRING
  "Flags used by the compiler during development." FORCE)

# FIXME: Do we want to add -DDEBUG to RelWithDebInfo?

# Set debug definitions
if (CMAKE_BUILD_TYPE STREQUAL "Developer" OR CMAKE_BUILD_TYPE STREQUAL "Debug")
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DDEBUG")
else()
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DNDEBUG")
endif()

# Add flags for generating code coverage reports
if (DOLFIN_ENABLE_CODE_COVERAGE AND CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
endif()

# Settings for Intel compilers
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
  # Use -isystem incluse flag with Intel compiler
  set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")

  # Stop spurious warnings from older Intel compilers
  if("${CMAKE_CXX_COMPILER_VERSION}" LESS "13")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -wd654,1125")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -wd654,1125")
    set(CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER} -wd654,1125")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -wd654,1125")
    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -wd654,1125")
  endif()
endif()

# Set system include flags to get around CMake bug on OSX with gcc See
# http://public.kitware.com/Bug/print_bug_page.php?bug_id=10837
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")
endif()

if (APPLE)
  set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")
  set(CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER} -Wno-long-long")
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wno-long-long")
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -Wno-long-long")
endif()

#------------------------------------------------------------------------------
# Check type sizes

include(CheckTypeSize)

# Check size of size_t
check_type_size("size_t" size_t_size)
if (size_t_size)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DDOLFIN_SIZE_T=${size_t_size}")
endif()

#------------------------------------------------------------------------------
# Check for MPI and OpenMP

# FIXME: Should be set CMake to use the MPI compiler wrappers?

if (DOLFIN_ENABLE_MPI)
  if (DOLFIN_AUTO_DETECT_MPI)
    find_package(MPI)
    set_package_properties(MPI PROPERTIES TYPE OPTIONAL
      DESCRIPTION "Message Passing Interface (MPI)"
      PURPOSE "Enables DOLFIN to run in parallel with MPI")
  else()
    # Assume user has set MPI compiler wrappers (via CXX, etc or
    # CMAKE_CXX_COMPILER, etc)
    set(MPI_CXX_FOUND TRUE)
    set(MPI_C_FOUND TRUE)
  endif()
endif()

# Test for OpenMP (but not for Clang, which does not support OpenMP)
if (DOLFIN_ENABLE_OPENMP)
  find_package(OpenMP)
  set_package_properties(OpenMP PROPERTIES TYPE OPTIONAL
    DESCRIPTION "Open Multi-Processing API"
    PURPOSE "Enables DOLFIN to run in parallel with OpenMP")
  include(CheckOpenMP)
  check_openmp_unsigned_int_loop_control_variable(OPENMP_UINT_TEST_RUNS)

=== bench/CMakeLists.txt ===
# Require CMake 2.8
cmake_minimum_required(VERSION 3.5)

# FIXME: Temporary fix for whitespace error
cmake_policy(SET CMP0004 OLD)

# Find DOLFIN config file (not used here, but check that benchmarks will be
# able to find it
find_package(DOLFIN REQUIRED)

# If config file is found, add all demo sub-directories, else print helper
# message
if (DOLFIN_FOUND)

  # Build list of all cpp directories
  file( GLOB_RECURSE list "main.cpp")
  list( SORT list )
  string(REGEX REPLACE "/main.cpp" "" list "${list}")

  # Add each C++ code directory
  foreach (cpp_dir ${list})
    #message(STATUS "Add C++ benchmark: ${cpp_dir}")
    add_subdirectory(${cpp_dir})
  endforeach()

  # Add fem/speedup/cpp manually (no main.cpp so not picked up automatically)
  add_subdirectory(fem/speedup/cpp)

else()

  message(STATUS "Could not locate DOLFINConfig.cmake file. Did you do 'make install' for the DOLFIN library and set the appropriate paths (source <build_dir>/dolfin.conf)?")

endif()

=== demo/CMakeLists.txt ===
project(dolfin-demos)

# Require CMake 2.8
cmake_minimum_required(VERSION 3.5)

# FIXME: Temporary fix for whitespace error
cmake_policy(SET CMP0004 OLD)

# Find DOLFIN config file (not used here, but check that the demo will
# be able to find it
find_package(DOLFIN PATHS ${CMAKE_BINARY_DIR} REQUIRED)

# If config file is found, add all demo sub-directories, else print
# helper message
if (DOLFIN_FOUND)

  # Directories that are commented out correspond to demos that have
  # not been implemented in C++

  # Documented demos
  add_subdirectory(documented/auto-adaptive-poisson/cpp)
  add_subdirectory(documented/bcs/cpp)
  add_subdirectory(documented/biharmonic/cpp)
  add_subdirectory(documented/built-in-meshes/cpp)
  add_subdirectory(documented/cahn-hilliard/cpp)
  add_subdirectory(documented/eigenvalue/cpp)
  add_subdirectory(documented/hyperelasticity/cpp)
  add_subdirectory(documented/mixed-poisson/cpp)
  add_subdirectory(documented/navier-stokes/cpp)
  add_subdirectory(documented/neumann-poisson/cpp)
  add_subdirectory(documented/nonlinear-poisson/cpp)
  add_subdirectory(documented/nonmatching-interpolation/cpp)
  add_subdirectory(documented/periodic/cpp)
  add_subdirectory(documented/poisson/cpp)
  add_subdirectory(documented/singular-poisson/cpp)
  #add_subdirectory(documented/singular-poisson-rst/cpp)
  add_subdirectory(documented/stokes-iterative/cpp)
  #add_subdirectory(documented/stokes-mini/cpp)
  add_subdirectory(documented/stokes-taylor-hood/cpp)
  add_subdirectory(documented/subdomains/cpp)
  #add_subdirectory(documented/subdomains-poisson/cpp)
  #add_subdirectory(documented/tensor-weighted-poisson/cpp)

  # Undocumented demos
  #add_subdirectory(undocumented/adaptive-poisson/cpp)
  add_subdirectory(undocumented/ale/cpp)
  add_subdirectory(undocumented/advection-diffusion/cpp)
  add_subdirectory(undocumented/auto-adaptive-navier-stokes/cpp)
  add_subdirectory(undocumented/block-matrix/cpp)
  #add_subdirectory(undocumented/buckling-tao/cpp)
  #add_subdirectory(undocumented/collision-detection/cpp)
  add_subdirectory(undocumented/coloring/cpp)
  #add_subdirectory(undocumented/compiled-extension-module/cpp)
  add_subdirectory(undocumented/conditional/cpp)
  add_subdirectory(undocumented/contact-vi-snes/cpp)
  add_subdirectory(undocumented/contact-vi-tao/cpp)
  #add_subdirectory(undocumented/coordinates/cpp)
  add_subdirectory(undocumented/curl-curl/cpp)
  add_subdirectory(undocumented/dg-advection-diffusion/cpp)
  add_subdirectory(undocumented/dg-poisson/cpp)
  add_subdirectory(undocumented/elasticity/cpp)
  add_subdirectory(undocumented/elastodynamics/cpp)
  #add_subdirectory(undocumented/elementplot/cpp)
  add_subdirectory(undocumented/eval/cpp)
  add_subdirectory(undocumented/extrapolation/cpp)
  add_subdirectory(undocumented/functional/cpp)
  #add_subdirectory(undocumented/ghost-mesh/cpp)
  #add_subdirectory(undocumented/interpolation/cpp)
  add_subdirectory(undocumented/lift-drag/cpp)
  add_subdirectory(undocumented/mesh-quality/cpp)
  #add_subdirectory(undocumented/mixed-poisson-sphere/cpp)
  #add_subdirectory(undocumented/mplot/cpp)
  #add_subdirectory(undocumented/multimesh/cpp)
  add_subdirectory(undocumented/multimesh-poisson/cpp)
  add_subdirectory(undocumented/multimesh-stokes/cpp)
  add_subdirectory(undocumented/meshfunction-refinement/cpp)
  #add_subdirectory(undocumented/multistage-solver/cpp)
  add_subdirectory(undocumented/nonmatching-projection/cpp)
  #add_subdirectory(undocumented/optimization/cpp)
  #add_subdirectory(undocumented/overlapping-regions/cpp)
  add_subdirectory(undocumented/parallel-refinement/cpp)
  add_subdirectory(undocumented/parameters/cpp)
  add_subdirectory(undocumented/plot/cpp)
  add_subdirectory(undocumented/poisson1D/cpp)
  add_subdirectory(undocumented/poisson1D-in-2D/cpp)
  add_subdirectory(undocumented/poisson-disc/cpp)
  #add_subdirectory(undocumented/point-integral/cpp)
  #add_subdirectory(undocumented/projection-interpolation/cpp)
  add_subdirectory(undocumented/refinement/cpp)
  #add_subdirectory(undocumented/smoothing/cpp)
  add_subdirectory(undocumented/spatial-coordinates/cpp)
  #add_subdirectory(undocumented/special-functions/cpp)
  #add_subdirectory(undocumented/sub-function-assignment/cpp)
  add_subdirectory(undocumented/submesh/cpp)
  add_subdirectory(undocumented/sym-dirichlet-bc/cpp)
  add_subdirectory(undocumented/time-series/cpp)
  #add_subdirectory(undocumented/timing/cpp)
  add_subdirectory(undocumented/waveguide/cpp)

  # Build list of all cpp demo directories
  #file(GLOB_RECURSE list "main.cpp")
  #list(SORT list)
  #string(REGEX REPLACE "/main.cpp" "" list "${list}")

  # Add each C++ demo directory
  #foreach (demo_dir ${list})
  #  add_subdirectory(${demo_dir})
  #endforeach()

else()

  message("Could not locate DOLFINConfig.cmake file. Did you do 'make install' for the DOLFIN library and set the appropriate paths (source <build_dir>/dolfin.conf)?")

endif()

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help
help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/*

.PHONY: html
html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

.PHONY: dirhtml
dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

.PHONY: singlehtml
singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

.PHONY: pickle
pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

.PHONY: json
json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

.PHONY: htmlhelp
htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

.PHONY: qthelp
qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/DOLFIN.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/DOLFIN.qhc"

.PHONY: applehelp
applehelp:
	$(SPHINXBUILD) -b applehelp $(ALLSPHINXOPTS) $(BUILDDIR)/applehelp
	@echo
	@echo "Build finished. The help book is in $(BUILDDIR)/applehelp."
	@echo "N.B. You won't be able to view it unless you put it in" \
	      "~/Library/Documentation/Help or install it in your application" \
	      "bundle."

.PHONY: devhelp
devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/DOLFIN"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/DOLFIN"
	@echo "# devhelp"

.PHONY: epub
epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

.PHONY: latex
latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

.PHONY: latexpdf
latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: latexpdfja
latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: text
text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

.PHONY: man
man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

.PHONY: texinfo
texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

.PHONY: info
info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

.PHONY: gettext
gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

.PHONY: changes
changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

.PHONY: linkcheck
linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

.PHONY: doctest
doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

.PHONY: coverage
coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

.PHONY: xml
xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

.PHONY: pseudoxml
pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== dolfin/CMakeLists.txt ===
set(DOLFIN_H dolfin.h)
install(FILES ${DOLFIN_H} DESTINATION ${DOLFIN_INCLUDE_DIR}
  COMPONENT Development)

# Configure and install dolfin/common/version.h file
string(REPLACE "+" "" DOLFIN_VERSION_MICRO_STRIPPED ${DOLFIN_VERSION_MICRO})
configure_file(${DOLFIN_SOURCE_DIR}/dolfin/common/version.h.in
  ${CMAKE_BINARY_DIR}/dolfin/common/version.h @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/dolfin/common/version.h
  DESTINATION ${DOLFIN_INCLUDE_DIR}/dolfin/common/
  COMPONENT Development
  )
include_directories(${CMAKE_BINARY_DIR})

#------------------------------------------------------------------------------
# DOLFIN source directories

# All files and directories in this directory
file(GLOB DOLFIN_CONTENT RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *)

# Initialize list
set(DOLFIN_DIRS)

# List of excluded files and directories
set(EXCLUDES ${DOLFIN_H} swig CMakeLists.txt)

# Iterate over all directories and files and append to DOLFIN_DIRS
foreach(_DIR_NAME ${DOLFIN_CONTENT})
  list(FIND EXCLUDES ${_DIR_NAME} INDEX_EXCLUDES)
  if (${INDEX_EXCLUDES} LESS 0)
    list(APPEND DOLFIN_DIRS ${_DIR_NAME})
  endif()
endforeach()

#------------------------------------------------------------------------------
# Install header files

# Initialize lists
set(DOLFIN_HEADERS)
set(DOLFIN_SOURCES)

foreach(DIR ${DOLFIN_DIRS})
  # Each subdirectory defines HEADERS and SOURCES
  add_subdirectory(${DIR})
  set(HEADERS_FULL_PATH)
  foreach(HEADER_FILE ${HEADERS})
    list(APPEND HEADERS_FULL_PATH ${CMAKE_CURRENT_SOURCE_DIR}/${DIR}/${HEADER_FILE})
  endforeach()
  install(FILES ${HEADERS_FULL_PATH} DESTINATION ${DOLFIN_INCLUDE_DIR}/dolfin/${DIR}
    COMPONENT Development)
  list(APPEND DOLFIN_HEADERS ${HEADERS_FULL_PATH})
  foreach(SOURCE_FILE ${SOURCES})
    list(APPEND DOLFIN_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/${DIR}/${SOURCE_FILE})
  endforeach()
endforeach()

#------------------------------------------------------------------------------
# Define libraries

add_library(dolfin ${DOLFIN_H} ${DOLFIN_HEADERS} ${DOLFIN_SOURCES})
set_target_properties(dolfin PROPERTIES ${DOLFIN_LIBRARY_PROPERTIES})

# Add dependency on the compile_ale_forms target
add_dependencies(dolfin compile_ale_forms)

#------------------------------------------------------------------------------
# Add include directories and libs of required packages

# NOTE: The include path for dependecies should be appended to
#       DOLFIN_DEP_INCLUDE_DIRECTORIES, unless there are issues, such
#       as unused variable that can cause build errors when using strict
#       compiler flags, in which case the path should be appended to
#       DOLFIN_DEP_SYSTEM_INCLUDE_DIRECTORIES

# UFC
list(APPEND DOLFIN_DEP_INCLUDE_DIRECTORIES ${UFC_INCLUDE_DIRS})

# Eigen3
list(APPEND DOLFIN_DEP_SYSTEM_INCLUDE_DIRECTORIES ${EIGEN3_INCLUDE_DIR})

# Boost
list(APPEND DOLFIN_DEP_SYSTEM_INCLUDE_DIRECTORIES ${Boost_INCLUDE_DIR})
foreach (BOOST_PACKAGE ${DOLFIN_BOOST_COMPONENTS_PUBLIC})
  target_link_libraries(dolfin PUBLIC "Boost::${BOOST_PACKAGE}")
endforeach()
foreach (BOOST_PACKAGE ${DOLFIN_BOOST_COMPONENTS_PRIVATE})
  target_link_libraries(dolfin PRIVATE "Boost::${BOOST_PACKAGE}")
endforeach()

#------------------------------------------------------------------------------

# HDF5
if (DOLFIN_ENABLE_HDF5 AND HDF5_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_HDF5")
  list(APPEND DOLFIN_CXX_DEFINITIONS ${HDF5_DEFINITIONS})
  list(APPEND DOLFIN_DEP_SYSTEM_INCLUDE_DIRECTORIES ${HDF5_INCLUDE_DIRS})
  list(APPEND DOLFIN_LINK_FLAGS ${HDF5_LINK_FLAGS})
  target_link_libraries(dolfin PRIVATE ${HDF5_C_LIBRARIES})
endif()

# Trilinos
if (DOLFIN_ENABLE_TRILINOS AND DOLFIN_TRILINOS_PACKAGES_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_TRILINOS")
  list(APPEND DOLFIN_CXX_DEFINITIONS ${DOLFIN_TRILINOS_DEFINITIONS})
  list(APPEND DOLFIN_DEP_SYSTEM_INCLUDE_DIRECTORIES ${Trilinos_INCLUDE_DIRS})
  target_link_libraries(dolfin PUBLIC ${DOLFIN_TRILINOS_LIBRARIES})
endif()

# SLEPC
if (DOLFIN_ENABLE_PETSC AND DOLFIN_ENABLE_SLEPC AND SLEPC_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_SLEPC")
  list(APPEND DOLFIN_DEP_INCLUDE_DIRECTORIES ${SLEPC_INCLUDE_DIRS})
  target_link_libraries(dolfin PUBLIC ${SLEPC_LIBRARIES})
  if (SLEPC_STATIC_LIBRARIES)
    target_link_libraries(dolfin PRIVATE ${SLEPC_STATIC_LIBRARIES})
  endif()
endif()

# PETSc
if (DOLFIN_ENABLE_PETSC AND PETSC_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_PETSC")
  list(APPEND DOLFIN_DEP_SYSTEM_INCLUDE_DIRECTORIES ${PETSC_INCLUDE_DIRS})
  target_link_libraries(dolfin PUBLIC ${PETSC_LIBRARIES})
  if (PETSC_STATIC_LIBRARIES)
    target_link_libraries(dolfin PRIVATE ${PETSC_STATIC_LIBRARIES})
  endif()
endif()

# petsc4py
if (DOLFIN_ENABLE_PETSC AND DOLFIN_ENABLE_PETSC4PY AND PETSC4PY_FOUND)
  list(APPEND DOLFIN_PYTHON_DEFINITIONS "-DHAS_PETSC4PY")
  list(APPEND PYTHON_INCLUDE_DIRS ${PETSC4PY_INCLUDE_DIRS})
endif()

# slepc4py
if (DOLFIN_ENABLE_SLEPC AND DOLFIN_ENABLE_SLEPC4PY AND SLEPC4PY_FOUND)
  list(APPEND DOLFIN_PYTHON_DEFINITIONS "-DHAS_SLEPC4PY")
  list(APPEND PYTHON_INCLUDE_DIRS ${SLEPC4PY_INCLUDE_DIRS})
endif()

# UMFPACK
if (DOLFIN_ENABLE_UMFPACK AND UMFPACK_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_UMFPACK")
  list(APPEND DOLFIN_DEP_INCLUDE_DIRECTORIES ${UMFPACK_INCLUDE_DIRS})
  target_link_libraries(dolfin PRIVATE ${UMFPACK_LIBRARIES})
endif()

# CHOLMOD
if (DOLFIN_ENABLE_CHOLMOD AND CHOLMOD_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_CHOLMOD")
  list(APPEND DOLFIN_DEP_INCLUDE_DIRECTORIES ${CHOLMOD_INCLUDE_DIRS})
  target_link_libraries(dolfin PRIVATE ${CHOLMOD_LIBRARIES})
endif()

# SCOTCH
if (DOLFIN_ENABLE_SCOTCH AND SCOTCH_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_SCOTCH")
  list(APPEND DOLFIN_DEP_INCLUDE_DIRECTORIES ${SCOTCH_INCLUDE_DIRS})
  target_link_libraries(dolfin PRIVATE ${SCOTCH_LIBRARIES})
endif()

# ParMETIS
if (DOLFIN_ENABLE_PARMETIS AND PARMETIS_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_PARMETIS")
  list(APPEND DOLFIN_DEP_SYSTEM_INCLUDE_DIRECTORIES ${PARMETIS_INCLUDE_DIRS})
  target_link_libraries(dolfin PRIVATE ${PARMETIS_LIBRARIES})
endif()

# ZLIB
if (DOLFIN_ENABLE_ZLIB AND ZLIB_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_ZLIB")
  list(APPEND DOLFIN_DEP_INCLUDE_DIRECTORIES ${ZLIB_INCLUDE_DIRS})
  target_link_libraries(dolfin PRIVATE ${ZLIB_LIBRARIES})
endif()

# MPI
if (DOLFIN_ENABLE_MPI AND MPI_CXX_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_MPI")
  list(APPEND DOLFIN_DEP_SYSTEM_INCLUDE_DIRECTORIES ${MPI_CXX_INCLUDE_PATH})
  list(APPEND DOLFIN_DEP_INCLUDE_DIRECTORIES ${MPI_CXX_INCLUDE_PATH})
  set(DOLFIN_CXX_FLAGS "${DOLFIN_CXX_FLAGS} ${MPI_CXX_COMPILE_FLAGS}")
  target_link_libraries(dolfin PUBLIC ${MPI_CXX_LIBRARIES})
endif()

# OpenMP
if (DOLFIN_ENABLE_OPENMP AND OPENMP_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_OPENMP")
  set(DOLFIN_CXX_FLAGS "${DOLFIN_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")

  if (MINGW)
    list(APPEND DOLFIN_LINK_FLAGS "${OpenMP_CXX_FLAGS}")
  endif()
endif()


# VTK
if (DOLFIN_ENABLE_VTK AND VTK_FOUND)
  include(${VTK_USE_FILE})

  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_VTK")
  list(APPEND DOLFIN_DEP_SYSTEM_INCLUDE_DIRECTORIES ${VTK_INCLUDE_DIRS})
  target_link_libraries(dolfin PRIVATE ${VTK_LIBRARIES})
endif()

#------------------------------------------------------------------------------
# Set compiler flags, include directories and library dependencies

# Add compiler include directories
include_directories(BEFORE ${DOLFIN_SOURCE_DIR})
include_directories(${DOLFIN_DEP_INCLUDE_DIRECTORIES})
include_directories(SYSTEM ${DOLFIN_DEP_SYSTEM_INCLUDE_DIRECTORIES})

# Add CXX definitions
add_definitions(${DOLFIN_CXX_DEFINITIONS})
add_definitions(-DDOLFIN_VERSION="${DOLFIN_VERSION}")

# Just add git revision flag to the one affected file
set_source_files_properties(common/defines.cpp PROPERTIES COMPILE_FLAGS
  "-DDOLFIN_GIT_COMMIT_HASH=\\\"${GIT_COMMIT_HASH}\\\" -DUFC_SIGNATURE=\\\"${UFC_SIGNATURE}\\\"")

# Add flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${DOLFIN_CXX_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${DOLFIN_LINK_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${DOLFIN_LINK_FLAGS}")

#------------------------------------------------------------------------------
# SWIG

if (PYTHONINTERP_FOUND AND PYTHONLIBS_FOUND AND SWIG_FOUND)

  # Add numpy defines to DOLFIN_PYTHON_DEFINITIONS
  if (NUMPY_FOUND)

    # Set numpy version define
    set(DOLFIN_PYTHON_DEFINITIONS ${DOLFIN_PYTHON_DEFINITIONS};-DNUMPY_VERSION_MAJOR=${NUMPY_VERSION_MAJOR};-DNUMPY_VERSION_MINOR=${NUMPY_VERSION_MINOR};-DNUMPY_VERSION_MICRO=${NUMPY_VERSION_MICRO})

    # Only set define for none deprecated API for NUMPY version 1.7
    # and larger
    if(NUMPY_VERSION VERSION_GREATER 1.6.2)
      set(DOLFIN_PYTHON_DEFINITIONS ${DOLFIN_PYTHON_DEFINITIONS} -DNPY_NO_DEPRECATED_API=NPY_${NUMPY_VERSION_MAJOR}_${NUMPY_VERSION_MINOR}_API_VERSION)
    endif()

  endif()

  add_subdirectory(swig)

endif()

#------------------------------------------------------------------------------
# Install

install(TARGETS dolfin EXPORT DOLFINTargets
  RUNTIME DESTINATION ${DOLFIN_LIB_DIR} COMPONENT RuntimeExecutables
  LIBRARY DESTINATION ${DOLFIN_LIB_DIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${DOLFIN_LIB_DIR} COMPONENT Development
  )

install(EXPORT DOLFINTargets DESTINATION ${DOLFIN_SHARE_DIR}/cmake)

#------------------------------------------------------------------------------
# Generate pkg-config file and install it

# Define packages that should be required by pkg-config file
set(PKG_REQUIRES "")

# Convert include dirs to -I<incdir> form
foreach(_inc_dir ${DOLFIN_DEP_INCLUDE_DIRECTORIES})
  set(PKG_INCLUDES "-I${_inc_dir} ${PKG_INCLUDES}")
endforeach()

foreach(_inc_dir ${DOLFIN_DEP_SYSTEM_INCLUDE_DIRECTORIES})
  set(PKG_INCLUDES "-I${_inc_dir} ${PKG_INCLUDES}")
endforeach()

# Convert compiler flags and definitions into space separated strings
string(REPLACE ";" " " PKG_CXXFLAGS "${CMAKE_CXX_FLAGS}")
string(REPLACE ";" " " PKG_LINKFLAGS "${CMAKE_EXE_LINKER_FLAGS}")
string(REPLACE ";" " " PKG_DEFINITIONS "${DOLFIN_CXX_DEFINITIONS}")

# Get link libraries
get_target_property(DOLFIN_TARGET_LINK_LIBRARIES dolfin INTERFACE_LINK_LIBRARIES)

# Convert libraries to -L<libdir> -l<lib> form
foreach(_lib ${DOLFIN_TARGET_LINK_LIBRARIES})
  # Add -Wl,option directives
  if ("${_lib}" MATCHES "-Wl,[^ ]*")
    set(PKG_LINKFLAGS "${_lib} ${PKG_LINKFLAGS}")
  else()
    string(REGEX REPLACE "(.?:?/[^ ]*)/lib([^ ]*)\\.(a|so|dylib|dll)" "-L\\1 -l\\2"
      _linkflags
      "${_lib}"
      )

    # Add libraries that matches the form -L<libdir> -l<lib>
    if ("${_linkflags}" MATCHES "-L.+ -l.+")
      set(PKG_LINKFLAGS "${_linkflags} ${PKG_LINKFLAGS}")
    endif()
  endif()
endforeach()

# Remove duplicated link flags
separate_arguments(PKG_LINKFLAGS)
list(REMOVE_DUPLICATES PKG_LINKFLAGS)
string(REPLACE ";" " " PKG_LINKFLAGS "${PKG_LINKFLAGS}")

# Add additional link flags
foreach(_linkflag ${DOLFIN_LINK_FLAGS})
  set(PKG_LINKFLAGS "${PKG_LINKFLAGS} ${_linkflag}")
endforeach()

# Configure and install pkg-config file
configure_file(${DOLFIN_CMAKE_DIR}/templates/dolfin.pc.in ${CMAKE_BINARY_DIR}/dolfin.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/dolfin.pc
  DESTINATION ${DOLFIN_PKGCONFIG_DIR}
  COMPONENT Development
  )

#------------------------------------------------------------------------------
# Generate CMake config files (DOLFINConfig{,Version}.cmake)

configure_file(${DOLFIN_CMAKE_DIR}/templates/DOLFINConfig.cmake.in
  ${CMAKE_BINARY_DIR}/dolfin/DOLFINConfig.cmake @ONLY)
configure_file(${DOLFIN_CMAKE_DIR}/templates/DOLFINConfigVersion.cmake.in
  ${CMAKE_BINARY_DIR}/dolfin/DOLFINConfigVersion.cmake @ONLY)
configure_file(${DOLFIN_CMAKE_DIR}/templates/UseDOLFIN.cmake.in
  ${CMAKE_BINARY_DIR}/dolfin/UseDOLFIN.cmake @ONLY)

install(
  FILES
    ${CMAKE_BINARY_DIR}/dolfin/DOLFINConfig.cmake
    ${CMAKE_BINARY_DIR}/dolfin/DOLFINConfigVersion.cmake
    ${CMAKE_BINARY_DIR}/dolfin/UseDOLFIN.cmake

=== dolfin/fem/CMakeLists.txt ===
set(HEADERS
  assemble.h
  assemble_local.h
  AssemblerBase.h
  Assembler.h
  BasisFunction.h
  DirichletBC.h
  DiscreteOperators.h
  DofMapBuilder.h
  DofMap.h
  dolfin_fem.h
  Equation.h
  fem_utils.h
  FiniteElement.h
  Form.h
  GenericDofMap.h
  LinearTimeDependentProblem.h
  LinearVariationalProblem.h
  LinearVariationalSolver.h
  LocalAssembler.h
  LocalSolver.h
  MultiMeshAssembler.h
  MultiMeshDirichletBC.h
  MultiMeshDofMap.h
  MultiMeshForm.h
  NonlinearVariationalProblem.h
  NonlinearVariationalSolver.h
  OpenMpAssembler.h
  PointSource.h
  solve.h
  SparsityPatternBuilder.h
  SystemAssembler.h
  UFC.h
  PARENT_SCOPE)

set(SOURCES
  assemble.cpp
  assemble_local.cpp
  AssemblerBase.cpp
  Assembler.cpp
  DirichletBC.cpp
  DiscreteOperators.cpp
  DofMapBuilder.cpp
  DofMap.cpp
  Equation.cpp
  fem_utils.cpp
  FiniteElement.cpp
  Form.cpp
  LinearTimeDependentProblem.cpp
  LinearVariationalProblem.cpp
  LinearVariationalSolver.cpp
  LocalAssembler.cpp
  LocalSolver.cpp
  MultiMeshAssembler.cpp
  MultiMeshDirichletBC.cpp
  MultiMeshDofMap.cpp
  MultiMeshForm.cpp
  NonlinearVariationalProblem.cpp
  NonlinearVariationalSolver.cpp
  OpenMpAssembler.cpp
  PointSource.cpp
  solve.cpp
  SparsityPatternBuilder.cpp
  SystemAssembler.cpp
  UFC.cpp
  PARENT_SCOPE)

=== dolfin/function/CMakeLists.txt ===
set(HEADERS
  assign.h
  CoefficientAssigner.h
  Constant.h
  dolfin_function.h
  Expression.h
  FunctionAssigner.h
  FunctionAXPY.h
  Function.h
  FunctionSpace.h
  GenericFunction.h
  LagrangeInterpolator.h
  MultiMeshCoefficientAssigner.h
  MultiMeshFunction.h
  MultiMeshFunctionSpace.h
  MultiMeshSubSpace.h
  SpecialFacetFunction.h
  SpecialFunctions.h
  PARENT_SCOPE)

set(SOURCES
  assign.cpp
  CoefficientAssigner.cpp
  Constant.cpp
  Expression.cpp
  FunctionAssigner.cpp
  FunctionAXPY.cpp
  Function.cpp
  FunctionSpace.cpp
  GenericFunction.cpp
  LagrangeInterpolator.cpp
  MultiMeshCoefficientAssigner.cpp
  MultiMeshFunction.cpp
  MultiMeshFunctionSpace.cpp
  MultiMeshSubSpace.cpp
  SpecialFacetFunction.cpp
  SpecialFunctions.cpp
  PARENT_SCOPE)

=== dolfin/generation/CMakeLists.txt ===
set(HEADERS
  BoxMesh.h
  dolfin_generation.h
  IntervalMesh.h
  RectangleMesh.h
  SphericalShellMesh.h
  UnitCubeMesh.h
  UnitDiscMesh.h
  UnitHexMesh.h
  UnitIntervalMesh.h
  UnitQuadMesh.h
  UnitSquareMesh.h
  UnitTetrahedronMesh.h
  UnitTriangleMesh.h
  PARENT_SCOPE)

set(SOURCES
  BoxMesh.cpp
  IntervalMesh.cpp
  RectangleMesh.cpp
  SphericalShellMesh.cpp
  UnitDiscMesh.cpp
  UnitHexMesh.cpp
  UnitQuadMesh.cpp
  UnitTetrahedronMesh.cpp
  UnitTriangleMesh.cpp
  PARENT_SCOPE)

=== dolfin/geometry/CMakeLists.txt ===
set(HEADERS
  BoundingBoxTree1D.h
  BoundingBoxTree2D.h
  BoundingBoxTree3D.h
  BoundingBoxTree.h
  CollisionDetection.h
  dolfin_geometry.h
  GenericBoundingBoxTree.h
  intersect.h
  IntersectionTriangulation.h
  MeshPointIntersection.h
  Point.h
  SimplexQuadrature.h
  PARENT_SCOPE)

set(SOURCES
  BoundingBoxTree.cpp
  CollisionDetection.cpp
  GenericBoundingBoxTree.cpp
  intersect.cpp
  IntersectionTriangulation.cpp
  MeshPointIntersection.cpp
  Point.cpp
  SimplexQuadrature.cpp
  PARENT_SCOPE)

=== dolfin/la/CMakeLists.txt ===
set(HEADERS
  Amesos2LUSolver.h
  BelosKrylovSolver.h
  BlockMatrix.h
  BlockVector.h
  CoordinateMatrix.h
  DefaultFactory.h
  dolfin_la.h
  EigenFactory.h
  EigenKrylovSolver.h
  EigenLUSolver.h
  EigenMatrix.h
  EigenVector.h
  GenericLinearAlgebraFactory.h
  GenericLinearOperator.h
  GenericLinearSolver.h
  GenericLUSolver.h
  GenericMatrix.h
  GenericTensor.h
  GenericVector.h
  Ifpack2Preconditioner.h
  IndexMap.h
  KrylovSolver.h
  LinearAlgebraObject.h
  LinearOperator.h
  LinearSolver.h
  LUSolver.h
  Matrix.h
  MueluPreconditioner.h
  PETScBaseMatrix.h
  PETScFactory.h
  PETScKrylovSolver.h
  PETScLinearOperator.h
  PETScLUSolver.h
  PETScMatrix.h
  PETScObject.h
  PETScOptions.h
  PETScPreconditioner.h
  PETScUserPreconditioner.h
  PETScVector.h
  Scalar.h
  SLEPcEigenSolver.h
  solve.h
  SparsityPattern.h
  TensorLayout.h
  test_nullspace.h
  TpetraFactory.h
  TpetraMatrix.h
  TpetraVector.h
  TrilinosParameters.h
  TrilinosPreconditioner.h
  Vector.h
  VectorSpaceBasis.h
  PARENT_SCOPE)

set(SOURCES
  Amesos2LUSolver.cpp
  BelosKrylovSolver.cpp
  BlockMatrix.cpp
  BlockVector.cpp
  CoordinateMatrix.cpp
  DefaultFactory.cpp
  EigenFactory.cpp
  EigenKrylovSolver.cpp
  EigenLUSolver.cpp
  EigenMatrix.cpp
  EigenVector.cpp
  GenericLinearSolver.cpp
  GenericMatrix.cpp
  Ifpack2Preconditioner.cpp
  IndexMap.cpp
  KrylovSolver.cpp
  LinearOperator.cpp
  LinearSolver.cpp
  LUSolver.cpp
  MueluPreconditioner.cpp
  PETScBaseMatrix.cpp
  PETScFactory.cpp
  PETScKrylovSolver.cpp
  PETScLinearOperator.cpp
  PETScLUSolver.cpp
  PETScMatrix.cpp
  PETScObject.cpp
  PETScOptions.cpp
  PETScPreconditioner.cpp
  PETScUserPreconditioner.cpp
  PETScVector.cpp
  SLEPcEigenSolver.cpp
  solve.cpp
  SparsityPattern.cpp
  TensorLayout.cpp
  test_nullspace.cpp
  TpetraFactory.cpp
  TpetraMatrix.cpp
  TpetraVector.cpp
  TrilinosParameters.cpp
  VectorSpaceBasis.cpp
  PARENT_SCOPE)

=== dolfin/mesh/CMakeLists.txt ===
set(HEADERS
  BoundaryComputation.h
  BoundaryMesh.h
  Cell.h
  CellType.h
  DistributedMeshTools.h
  dolfin_mesh.h
  DomainBoundary.h
  DynamicMeshEditor.h
  Edge.h
  Face.h
  FacetCell.h
  Facet.h
  HexahedronCell.h
  IntervalCell.h
  LocalMeshData.h
  LocalMeshValueCollection.h
  MeshColoring.h
  MeshConnectivity.h
  MeshData.h
  MeshDomains.h
  MeshEditor.h
  MeshEntity.h
  MeshEntityIteratorBase.h
  MeshEntityIterator.h
  MeshFunction.h
  MeshGeometry.h
  Mesh.h
  MeshHierarchy.h
  MeshOrdering.h
  MeshPartitioning.h
  MeshQuality.h
  MeshRelation.h
  MeshRenumbering.h
  MeshSmoothing.h
  MeshTopology.h
  MeshTransformation.h
  MeshValueCollection.h
  MultiMesh.h
  PeriodicBoundaryComputation.h
  PointCell.h
  QuadrilateralCell.h
  SubDomain.h
  SubMesh.h
  SubsetIterator.h
  TetrahedronCell.h
  TopologyComputation.h
  TriangleCell.h
  Vertex.h
  PARENT_SCOPE)

set(SOURCES
  BoundaryComputation.cpp
  BoundaryMesh.cpp
  CellType.cpp
  DistributedMeshTools.cpp
  DynamicMeshEditor.cpp
  Edge.cpp
  Face.cpp
  FacetCell.cpp
  Facet.cpp
  HexahedronCell.cpp
  IntervalCell.cpp
  LocalMeshData.cpp
  MeshColoring.cpp
  MeshConnectivity.cpp
  Mesh.cpp
  MeshData.cpp
  MeshDomains.cpp
  MeshEditor.cpp
  MeshEntity.cpp
  MeshFunction.cpp
  MeshGeometry.cpp
  MeshHierarchy.cpp
  MeshOrdering.cpp
  MeshPartitioning.cpp
  MeshQuality.cpp
  MeshRenumbering.cpp
  MeshSmoothing.cpp
  MeshTopology.cpp
  MeshTransformation.cpp
  MultiMesh.cpp
  PeriodicBoundaryComputation.cpp
  PointCell.cpp
  QuadrilateralCell.cpp
  SubDomain.cpp
  SubMesh.cpp
  TetrahedronCell.cpp
  TopologyComputation.cpp
  TriangleCell.cpp
  PARENT_SCOPE)

=== dolfin/plot/CMakeLists.txt ===
set(HEADERS
  dolfin_plot.h
  ExpressionWrapper.h
  GenericVTKPlottable.h
  plot.h
  VTKPlottableDirichletBC.h
  VTKPlottableGenericFunction1D.h
  VTKPlottableGenericFunction.h
  VTKPlottableMeshFunction.h
  VTKPlottableMesh.h
  VTKPlotter.h
  VTKWindowOutputStage.h
  PARENT_SCOPE)

set(SOURCES
  ExpressionWrapper.cpp
  plot.cpp
  VTKPlottableDirichletBC.cpp
  VTKPlottableGenericFunction1D.cpp
  VTKPlottableGenericFunction.cpp
  VTKPlottableMesh.cpp
  VTKPlottableMeshFunction.cpp
  VTKPlotter.cpp
  VTKWindowOutputStage.cpp
  PARENT_SCOPE)

=== debian/changelog ===
dolfin (2016.2.0-5build3) artful; urgency=medium

  * No-change rebuild for GCC 7 abi mangling change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 07 Aug 2017 15:13:48 +0000

dolfin (2016.2.0-5build2) artful; urgency=medium

  * No-change rebuild to build with python3.6.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jul 2017 18:45:56 +0000

dolfin (2016.2.0-5build1) artful; urgency=medium

  * Rebuild against new libmumps-5.1.1.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 17 Jul 2017 11:13:45 +0200

dolfin (2016.2.0-5) unstable; urgency=medium

  * libdolfin-dev depends on either the python2 or python3 version of
    modules (enables python3-only installation).

 -- Drew Parsons <dparsons@debian.org>  Thu, 06 Jul 2017 15:21:57 +0800

dolfin (2016.2.0-4) unstable; urgency=medium

  [ Johannes Ring ]
  * d/rules:
    - Re-generate swig interface with correct Python version
      before build and install. Closes: #863829.
    - Build for Python 2 after Python 3 by switching the order in
      PYVERS, since Python 2 is default.
  * Add patch vtk-python2-only-cmake-usefile.patch that disables the
    vtk section in UseDOLFIN.cmake for Python 3. Closes: #863828.
  * d/control: Add python-ffc to Depends for binary package
    libdolfin-dev (provides ufc.h).

 -- Drew Parsons <dparsons@debian.org>  Wed, 07 Jun 2017 12:14:40 +0800

dolfin (2016.2.0-3) unstable; urgency=medium

  [ Drew Parsons ]
  * Enable petsc/slepc dependencies on kfreebsd. Note that PETSc
    support in dolfin on kfreebsd is not in fact active due to linking
    problems during configuration tests, but dolfin builds
    successfully without it. Closes: #822971.

  [ Johannes Ring ]
  * Support Python 3: new packages python3-dolfin and python3-dolfin-dbg.

 -- Drew Parsons <dparsons@debian.org>  Tue, 30 May 2017 16:17:28 +0800

dolfin (2016.2.0-2) unstable; urgency=medium

  * Dolfin depends on specific 3.7.X patch releases of PETSc and SLEPc
    (see dolfin.pc, DOLFINConfig.cmake)

 -- Drew Parsons <dparsons@debian.org>  Tue, 24 Jan 2017 06:18:32 +0800

dolfin (2016.2.0-1) unstable; urgency=medium

  [ Drew Parsons ]
  * Drop HDF5 Fortran configuration (it's not actually used).
  * Tighten build and python-dolfin fenics dependencies to the
    FENiCS minor version: (>= 2016.2.0), (<< 2016.3~)

  [ Johannes Ring ]
  * New upstream release.
  * d/watch: Check pgp signature.
  * d/control:
    - Update package names (libdolfin2016.1 -> libdolfin2016.2
      and libdolfin2016.1-dbg -> libdolfin2016.2-dbg).
    - Bump minimum required version for python-instant, python-ufl and
      python-ffc to 2016.2.
    - Add python-dijitso to Build-Depends and Depends for binary package
      python-dolfin.

 -- Drew Parsons <dparsons@debian.org>  Wed, 21 Dec 2016 16:47:36 +0800

=== debian/control ===
Source: dolfin
Section: math
Priority: extra
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Johannes Ring <johannr@simula.no>,
 Drew Parsons <dparsons@debian.org>
Build-Depends:
 cmake (>= 2.8.0),
 debhelper (>= 9),
 dh-python,
 gfortran,
 libboost-chrono-dev,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-math-dev,
 libboost-mpi-dev,
 libboost-program-options-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-timer-dev,
 libeigen3-dev,
 libhdf5-mpi-dev,
 libsuitesparse-dev,
 libscotch-dev,
 libvtk6-dev,
 libxml2-dev,
 mpi-default-dev,
 petsc-dev (>= 3.6.4.dfsg1-2),
 slepc-dev (>= 3.6.3.dfsg1-6),
 python-petsc4py,
 python-slepc4py,
 python3-petsc4py,
 python3-slepc4py,
 pkg-config,
 python-dev,
 python3-dev,
 python-pkg-resources,
 python3-pkg-resources,
 python-ffc (>= 2016.2.0), python-ffc (<< 2016.3.0),
 python-dijitso (>= 2016.2.0), python-dijitso (<< 2016.3.0),
 python3-ffc (>= 2016.2.0), python3-ffc (<< 2016.3.0),
 python3-dijitso (>= 2016.2.0), python3-dijitso (<< 2016.3.0),
 python-numpy,
 python3-numpy,
 python-ply,
 python3-ply,
 swig3.0 (>= 3.0.3)
Standards-Version: 3.9.8
X-Python-Version: >= 2.7
X-Python3-Version: >= 3.4
Homepage: http://fenicsproject.org
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/fenics/dolfin.git
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/fenics/dolfin.git

Package: libdolfin-dev
Section: libdevel
Architecture: any
Depends:
 cmake (>= 2.8.0),
 libboost-chrono-dev,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-math-dev,
 libboost-mpi-dev,
 libboost-program-options-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-timer-dev,
 libdolfin2016.2 (= ${binary:Version}),
 libeigen3-dev,
 libhdf5-mpi-dev,
 libsuitesparse-dev,
 libscotch-dev,
 libvtk6-dev,
 libxml2-dev,
 pkg-config,
 python-ffc (>= ${source:Upstream-Version}) | python3-ffc (>= ${source:Upstream-Version}), python-ffc (<< ${source:Next-Upstream-Version}) | python3-ffc (<< ${source:Next-Upstream-Version}),
 ${petsc:Depends},
 ${python-petsc4py-alt:Depends},
 ${misc:Depends}
Conflicts:
 libdolfin0-dev,
 libdolfin1.0-dev,
 libdolfin1.1-dev,
 libdolfin1.2-dev,
 libdolfin1.3-dev,
 libdolfin1.4-dev
Replaces:
 libdolfin0-dev,
 libdolfin1.0-dev,
 libdolfin1.1-dev,
 libdolfin1.2-dev,
 libdolfin1.3-dev,
 libdolfin1.4-dev
Description: Shared links and header files for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files.

Package: libdolfin2016.2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: dolfin-doc, libdolfin2016.2-dbg, python-dolfin
Description: Shared libraries for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries.

Package: libdolfin2016.2-dbg
Section: debug
Architecture: any
Depends: libdolfin2016.2 (= ${binary:Version}), ${misc:Depends}
Description: Shared libraries with debugging symbols for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries with debugging symbols.

Package: python-dolfin
Section: python
Architecture: any
Depends:
 libdolfin-dev (= ${binary:Version}),
 libdolfin2016.2 (= ${binary:Version}),
 python-ffc (>= ${source:Upstream-Version}), python-ffc (<< ${source:Next-Upstream-Version}),
 python-dijitso (>= ${source:Upstream-Version}), python-dijitso (<< ${source:Next-Upstream-Version}),
 python-instant (>= ${source:Upstream-Version}), python-instant (<< ${source:Next-Upstream-Version}),
 python-numpy,
 python-ply,
 python-six,
 python-sympy,
 python-ufl (>= ${source:Upstream-Version}), python-ufl (<< ${source:Next-Upstream-Version}),
 ${python-petsc4py:Depends},
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends},
 ${swig:Depends}
Suggests: dolfin-doc
Description: Python interface for DOLFIN (Python 2)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python interface for DOLFIN (Python 2).

Package: python3-dolfin
Section: python
Architecture: any
Depends:
 libdolfin-dev (= ${binary:Version}),
 libdolfin2016.2 (= ${binary:Version}),
 python3-ffc (>= ${source:Upstream-Version}), python3-ffc (<< ${source:Next-Upstream-Version}),
 python3-dijitso (>= ${source:Upstream-Version}), python3-dijitso (<< ${source:Next-Upstream-Version}),
 python3-instant (>= ${source:Upstream-Version}), python3-instant (<< ${source:Next-Upstream-Version}),
 python3-numpy,
 python3-ply,
 python3-six,
 python3-sympy,
 python3-ufl (>= ${source:Upstream-Version}), python3-ufl (<< ${source:Next-Upstream-Version}),
 ${python3-petsc4py:Depends},
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
 ${swig:Depends}
Suggests: dolfin-doc
Description: Python interface for DOLFIN (Python 3)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python interface for DOLFIN (Python 3).

Package: python-dolfin-dbg
Section: debug
Architecture: any
Depends:
 python-dolfin (= ${binary:Version}),
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends}
Suggests: dolfin-doc
Description: Python 2 extension modules for DOLFIN with debugging symbols
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python 2 extensions modules for DOLFIN with
 debugging symbols.

Package: python3-dolfin-dbg
Section: debug
Architecture: any
Depends:
 python3-dolfin (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends}
Suggests: dolfin-doc
Description: Python 3 extension modules for DOLFIN with debugging symbols
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python 3 extensions modules for DOLFIN with
 debugging symbols.

Package: dolfin-doc
Architecture: all
Section: doc
Depends:
 libdolfin-dev (>= ${source:Version}),
 python-dolfin (>= ${source:Version}),
 ${misc:Depends}
Suggests: cmake (>= 2.8.0)
Description: Documentation and demo programs for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains documentation and demo programs for DOLFIN.

Package: dolfin-bin
Architecture: all
Depends:
 python-dolfin (>= ${source:Version}),
 ${misc:Depends},
 ${python:Depends}
Description: Executable scripts for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains executable scripts for DOLFIN.

=== debian/rules ===
#!/usr/bin/make -f

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')

FENICS_RELEASE_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)
FENICS_MAJOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
FENICS_MINOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
FENICS_VERSION=$(FENICS_MAJOR_VERSION).$(FENICS_MINOR_VERSION)
FENICS_NEXT_VERSION=$(FENICS_MAJOR_VERSION).$(shell echo $$(( $(FENICS_MINOR_VERSION) + 1 )) )

# Allow test programs that uses OpenMPI to run
export OMPI_MCA_plm_rsh_agent=/bin/false

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_BUILD_MULTIARCH ?= $(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)

# Disable MPI on lam architectures
include /usr/share/mpi-default-dev/debian_defaults
ifeq ($(findstring $(DEB_BUILD_ARCH),$(OPENMPI_ARCHITECTURES)),)
ENABLE_MPI=OFF
else
ENABLE_MPI=ON
endif

BUILDDIR = $(CURDIR)/debian/build
DOLFIN_HOME = $(CURDIR)/$(DEB_SRCDIR)
USCAN_DESTDIR := $(CURDIR)
PY2VERS := $(shell pyversions --requested debian/control | tac -s' ')
PY3VERS := $(shell py3versions --requested debian/control | tac -s' ')
PYVERS = $(PY3VERS) $(PY2VERS)

# extract PETSc version from petsc-dev
PETSC_DEB_VERSION=$(shell dpkg -s petsc-dev | awk '/Version:/ {print $2}')
# extract the current PETSc version
PETSC_UPSTREAM_VERSION=$(shell pkg-config --modversion PETSc)
# "Major" version is the first number in the upstream version (major.minor.release)
PETSC_MAJOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
# "Minor" version is the second number in the upstream version (major.minor.release)
PETSC_MINOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
PETSC_VERSION=$(PETSC_MAJOR_VERSION).$(PETSC_MINOR_VERSION)
PETSC_VERSION_NEXT=$(shell echo $(PETSC_MAJOR_VERSION).$$(($(PETSC_MINOR_VERSION)+1)))

SLEPC_UPSTREAM_VERSION=$(shell pkg-config --modversion SLEPc)

PETSC_DIR=/usr/lib/petscdir/$(PETSC_VERSION)-real
# SLEPc version must match PETSc
SLEPSC_DIR=/usr/lib/slepcdir/$(PETSC_VERSION)-real

CMAKE_OPTS := \
	-D CMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
	-D BUILD_SHARED_LIBS:BOOL=ON \
	-D CMAKE_SKIP_RPATH:BOOL=ON \
	-D CMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
	-D DOLFIN_ENABLE_TRILINOS:BOOL=OFF \
	-D DOLFIN_ENABLE_HDF5:BOOL=ON \
	-D HDF5_C_COMPILER_EXECUTABLE:FILEPATH=/usr/bin/h5pcc \
	-D DOLFIN_ENABLE_VTK:BOOL=ON \
	-D DOLFIN_ENABLE_QT:BOOL=OFF \
	-D DOLFIN_ENABLE_PARMETIS:BOOL=OFF \
	-D DOLFIN_ENABLE_PASTIX:BOOL=OFF \
	-D DOLFIN_ENABLE_SCOTCH:BOOL=ON \
	-D DOLFIN_ENABLE_PETSC4PY:BOOL=ON \
	-D DOLFIN_ENABLE_SLEPC4PY:BOOL=ON \
	-D DOLFIN_ENABLE_SPHINX:BOOL=OFF \
	-D DOLFIN_ENABLE_DOCS:BOOL=OFF \
	-D DOLFIN_ENABLE_UNIT_TESTS:BOOL=OFF \
	-D SWIG_EXECUTABLE:FILEPATH=/usr/bin/swig \
	-D DOLFIN_ENABLE_MPI:BOOL=$(ENABLE_MPI) \
	-D PETSC_DIR:PATH=$(PETSC_DIR) \
	-D SLEPC_DIR:PATH=$(SLEPSC_DIR) \
	-D DOLFIN_LIB_DIR:PATH=lib/$(DEB_BUILD_MULTIARCH) \
	-D DOLFIN_PKGCONFIG_DIR:PATH=lib/$(DEB_BUILD_MULTIARCH)/pkgconfig \
	-D CMAKE_CXX_FLAGS:STRING="-fpermissive" \
	$(DOLFIN_HOME)

%:
	dh $@ --buildsystem=cmake --with python2,python3 --parallel

override_dh_compress:
	dh_compress -X.py -X.cpp -X.h -X.pdf -X.ufl

override_dh_auto_clean:
	for v in $(PYVERS); do \
	    dh_auto_clean --builddirectory=$(BUILDDIR)-$$v; \
	done

override_dh_auto_configure:
	for v in $(PYVERS); do \
	    if [ "$$v" = "python2.7" ]; then \
	        dh_auto_configure --builddirectory=$(BUILDDIR)-$$v -- \
	           -D PYTHON_EXECUTABLE:FILEPATH=/usr/bin/$$v \
	           -D DOLFIN_USE_PYTHON3:BOOL=OFF \
	           -- $(CMAKE_OPTS) ;\
	    else \
	        dh_auto_configure --builddirectory=$(BUILDDIR)-$$v -- \
	           -D PYTHON_EXECUTABLE:FILEPATH=/usr/bin/$$v \
	           -D DOLFIN_USE_PYTHON3:BOOL=ON \
	           -- $(CMAKE_OPTS) ;\
	    fi; \
	done

override_dh_auto_build:
	for v in $(PYVERS); do \
	   $$v cmake/scripts/generate-swig-interface.py; \
	   dh_auto_build --builddirectory=$(BUILDDIR)-$$v; \
	done

override_dh_auto_install:
	for v in $(PYVERS); do \
	   $$v cmake/scripts/generate-swig-interface.py; \
	   dh_auto_install --builddirectory=$(BUILDDIR)-$$v; \
	done
	dh_numpy
	dh_numpy3
	sed -i "s/-D_FORTIFY_SOURCE=2//g" $(CURDIR)/debian/tmp/usr/lib/$(DEB_BUILD_MULTIARCH)/pkgconfig/dolfin.pc
	sed -i "s|-DNDEBUG||g" $(CURDIR)/debian/tmp/usr/lib/$(DEB_BUILD_MULTIARCH)/pkgconfig/dolfin.pc

override_dh_auto_test:
	for v in $(PYVERS); do \
	   dh_auto_test --builddirectory=$(BUILDDIR)-$$v; \
	done

# set petsc:Depends to something like "libpetsc3.7.5-dev, libslepc3.7.3-dev, python-petsc4py (>= 3.7), python-petsc4py (<<3.8), python-slepc4py (>= 3.7), python-slepc4py (<<3.8)"
PETSC_DEV_DEPENDS="libpetsc$(PETSC_UPSTREAM_VERSION)-dev, libslepc$(SLEPC_UPSTREAM_VERSION)-dev"
# slepc4py version must match petsc4py (using the PETSc minor version, not the patch release)
PETSC4PY_DEPENDS=python-petsc4py (>= $(PETSC_VERSION)), python-petsc4py (<< $(PETSC_VERSION_NEXT)), python-slepc4py (>= $(PETSC_VERSION)), python-slepc4py (<< $(PETSC_VERSION_NEXT))
PETSC4PY_DEPENDS_PY3=python3-petsc4py (>= $(PETSC_VERSION)), python3-petsc4py (<< $(PETSC_VERSION_NEXT)), python3-slepc4py (>= $(PETSC_VERSION)), python3-slepc4py (<< $(PETSC_VERSION_NEXT))
PETSC4PY_DEPENDS_ALT=python-petsc4py (>= $(PETSC_VERSION)) | python3-petsc4py (>= $(PETSC_VERSION)), python-petsc4py (<< $(PETSC_VERSION_NEXT)) | python3-petsc4py (<< $(PETSC_VERSION_NEXT)), python-slepc4py (>= $(PETSC_VERSION)) | python3-slepc4py (>= $(PETSC_VERSION)), python-slepc4py (<< $(PETSC_VERSION_NEXT)) | python3-slepc4py (<< $(PETSC_VERSION_NEXT))
override_dh_gencontrol:
	# We have a tight dependency on swig - #675207
	set -e; \
	swig_version=$$(dpkg-query -W swig3.0 | cut -f 2 | cut -d- -f 1); \
	next_swig_version="$${swig_version%.*}.$$(($${swig_version##*.} + 1))"; \
	echo "swig:Depends=swig3.0 (>= $$swig_version), swig3.0 (<< $$next_swig_version~)" >> debian/python-dolfin.substvars
	echo "python-petsc4py:Depends=$(PETSC4PY_DEPENDS)" >> debian/python-dolfin.substvars
	echo "python3-petsc4py:Depends=$(PETSC4PY_DEPENDS_PY3)" >> debian/python3-dolfin.substvars
	echo "python-petsc4py-alt:Depends=$(PETSC4PY_DEPENDS_ALT)" >> debian/libdolfin-dev.substvars
	dh_gencontrol -- -Vpetsc:Depends=$(PETSC_DEV_DEPENDS) -Vsource:Next-Upstream-Version=$(FENICS_NEXT_VERSION)~

override_dh_strip:
	dh_strip -a --package=libdolfin$(FENICS_VERSION) --dbg-package=libdolfin$(FENICS_VERSION)-dbg -Xpython
	dh_strip -a --package=python-dolfin --dbg-package=python-dolfin-dbg -Xpython3
	dh_strip -a --package=python3-dolfin --dbg-package=python3-dolfin-dbg -Xpython2

override_dh_installman:
	dh_installman


.PHONY: get-orig-source override_dh_strip
get-orig-source:
	uscan --force-download --verbose --destdir $(USCAN_DESTDIR)
